/*
 *  Demo of COSS Relationship Service
 *  Copyright (C) 1998 Karel Gardas
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 mico@informatik.uni-frankfurt.de
 *  or to my private e-mail:
 *                 gardask@alpha.inf.upol.cz
 */


#include <mico/Role_impl.h>
#include <mico/Relationship_impl.h>
#include "Containment.h"


#ifndef __Containment_impl_h__
#define __Containment_impl_h__


class ContainsRole_impl : virtual public Role_impl,
			  virtual public Containment::ContainsRole_skel
{
public:
  ContainsRole_impl ();
  ContainsRole_impl (CORBA::Object_ptr obj);
  ContainsRole_impl (CosRelationships::RelatedObject_ptr, CORBA::Long);

};


class ContainedInRole_impl : virtual public Role_impl,
			     virtual public Containment::ContainedInRole_skel
{
public:
  ContainedInRole_impl ();
  ContainedInRole_impl (CORBA::Object_ptr obj);
  ContainedInRole_impl (CosRelationships::RelatedObject_ptr, CORBA::Long);

};


class Containment_impl : virtual public Relationship_impl,
			 virtual public Containment::Relationship_skel
{
public:    
  Containment_impl ();
  
  Containment_impl (CORBA::Object_ptr obj);
  Containment_impl (CosRelationships::NamedRoles nr);

  virtual CORBA::Boolean _save_object ();
};


class ContainsRoleLoader : public CORBA::BOAObjectRestorer
{
public:
  CORBA::Boolean restore (CORBA::Object_ptr obj);
};


class ContainedInRoleLoader : public CORBA::BOAObjectRestorer
{
public:
  CORBA::Boolean restore (CORBA::Object_ptr obj);
};


class ContainmentLoader : public CORBA::BOAObjectRestorer
{
public:
  CORBA::Boolean restore (CORBA::Object_ptr obj);
};


#endif

