/*
 *  Demo of COSS Relationship Service
 *  Copyright (C) 1998 Karel Gardas
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Send comments and/or bug reports to:
 *                 mico@informatik.uni-frankfurt.de
 *  or to my private e-mail:
 *                 gardask@alpha.inf.upol.cz
 */


#include <mico/Role_impl.h>
#include <mico/Relationship_impl.h>
#include "Ownership.h"


#ifndef __Ownership_impl_h__
#define __Ownership_impl_h__


class OwnerRole_impl : virtual public Role_impl,
		       virtual public Ownership::OwnerRole_skel
{
public:
  OwnerRole_impl ();
  OwnerRole_impl (CORBA::Object_ptr obj);
  OwnerRole_impl (CosRelationships::RelatedObject_ptr, CORBA::Long);

};


class OwnedByRole_impl : virtual public Role_impl,
			 virtual public Ownership::OwnedByRole_skel
{
public:
  OwnedByRole_impl ();
  OwnedByRole_impl (CORBA::Object_ptr obj);
  OwnedByRole_impl (CosRelationships::RelatedObject_ptr, CORBA::Long);

};


class Ownership_impl : 	virtual public Relationship_impl,
			virtual public Ownership::Relationship_skel
{
public:    
  Ownership_impl ();
  Ownership_impl (CORBA::Object_ptr obj);
  Ownership_impl (CosRelationships::NamedRoles nr);

};


class OwnerRoleLoader : public CORBA::BOAObjectRestorer
{
public:
  CORBA::Boolean restore (CORBA::Object_ptr obj);
};


class OwnedByRoleLoader : public CORBA::BOAObjectRestorer
{
public:
  CORBA::Boolean restore (CORBA::Object_ptr obj);
};


class OwnershipLoader : public CORBA::BOAObjectRestorer
{
public:
  CORBA::Boolean restore (CORBA::Object_ptr obj);
};


#endif

