/*
 *  MICO --- a free CORBA implementation
 *  Copyright (C) 1997-98 Kay Roemer & Arno Puder
 *
 *  This file was automatically generated. DO NOT EDIT!
 */

#if !defined(__TYPEREPO_H__) || defined(MICO_NO_TOPLEVEL_MODULES)
#define __TYPEREPO_H__

#ifndef MICO_NO_TOPLEVEL_MODULES
#include <CORBA.h>
#include <mico/throw.h>
#endif

#ifdef MICO_IN_GENERATED_CODE
#include <../../include/mico/trader.h>
#else
#define MICO_IN_GENERATED_CODE
#include <../../include/mico/trader.h>
#undef MICO_IN_GENERATED_CODE
#endif

#ifndef MICO_NO_TOPLEVEL_MODULES
MICO_NAMESPACE_DECL CosTradingRepos {
#endif

#if !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE_CosTradingRepos)


class ServiceTypeRepository;
typedef ServiceTypeRepository *ServiceTypeRepository_ptr;
typedef ServiceTypeRepository_ptr ServiceTypeRepositoryRef;
typedef ObjVar<ServiceTypeRepository> ServiceTypeRepository_var;
typedef ServiceTypeRepository_var ServiceTypeRepository_out;


// Common definitions for interface ServiceTypeRepository
class ServiceTypeRepository : 
  virtual public CORBA::Object
{
  public:
    virtual ~ServiceTypeRepository();

    typedef ServiceTypeRepository_ptr _ptr_type;
    typedef ServiceTypeRepository_var _var_type;

    static ServiceTypeRepository_ptr _duplicate( ServiceTypeRepository_ptr obj );
    static ServiceTypeRepository_ptr _narrow( CORBA::Object_ptr obj );
    static ServiceTypeRepository_ptr _narrow( CORBA::AbstractBase_ptr obj );
    static ServiceTypeRepository_ptr _nil();

    virtual void *_narrow_helper( const char *repoid );
    static vector<CORBA::Narrow_proto> *_narrow_helpers;
    static bool _narrow_helper2( CORBA::Object_ptr obj );

    typedef SequenceTmpl<CosTrading::ServiceTypeName_var,MICO_TID_DEF> ServiceTypeNameSeq;
    #ifdef _WINDOWS
    static ServiceTypeNameSeq _dummy_ServiceTypeNameSeq;
    #endif
    typedef TSeqVar<SequenceTmpl<CosTrading::ServiceTypeName_var,MICO_TID_DEF> > ServiceTypeNameSeq_var;
    typedef ServiceTypeNameSeq_var ServiceTypeNameSeq_out;

    enum PropertyMode {
      PROP_NORMAL = 0,
      PROP_READONLY,
      PROP_MANDATORY,
      PROP_MANDATORY_READONLY
    };

    typedef PropertyMode& PropertyMode_out;

    struct PropStruct;
    typedef TVarVar<PropStruct> PropStruct_var;
    typedef PropStruct_var PropStruct_out;

    struct PropStruct {
      typedef PropStruct_var _var_type;
      #ifdef HAVE_EXPLICIT_STRUCT_OPS
      PropStruct();
      ~PropStruct();
      PropStruct( const PropStruct& s );
      PropStruct& operator=( const PropStruct& s );
      #endif //HAVE_EXPLICIT_STRUCT_OPS

      CosTrading::PropertyName_var name;
      CORBA::TypeCode_var value_type;
      PropertyMode mode;
    };

    typedef SequenceTmpl<PropStruct,MICO_TID_DEF> PropStructSeq;
    #ifdef _WINDOWS
    static PropStructSeq _dummy_PropStructSeq;
    #endif
    typedef TSeqVar<SequenceTmpl<PropStruct,MICO_TID_DEF> > PropStructSeq_var;
    typedef PropStructSeq_var PropStructSeq_out;

    typedef char* Identifier;
    typedef CORBA::String_var Identifier_var;
    typedef CORBA::String_out Identifier_out;

    struct IncarnationNumber;
    typedef TFixVar<IncarnationNumber> IncarnationNumber_var;
    typedef IncarnationNumber_var IncarnationNumber_out;

    struct IncarnationNumber {
      typedef IncarnationNumber_var _var_type;
      #ifdef HAVE_EXPLICIT_STRUCT_OPS
      IncarnationNumber();
      ~IncarnationNumber();
      IncarnationNumber( const IncarnationNumber& s );
      IncarnationNumber& operator=( const IncarnationNumber& s );
      #endif //HAVE_EXPLICIT_STRUCT_OPS

      CORBA::ULong high;
      CORBA::ULong low;
    };

    struct TypeStruct;
    typedef TVarVar<TypeStruct> TypeStruct_var;
    typedef TypeStruct_var TypeStruct_out;

    struct TypeStruct {
      typedef TypeStruct_var _var_type;
      #ifdef HAVE_EXPLICIT_STRUCT_OPS
      TypeStruct();
      ~TypeStruct();
      TypeStruct( const TypeStruct& s );
      TypeStruct& operator=( const TypeStruct& s );
      #endif //HAVE_EXPLICIT_STRUCT_OPS

      Identifier_var if_name;
      PropStructSeq props;
      ServiceTypeNameSeq super_types;
      CORBA::Boolean masked;
      IncarnationNumber incarnation;
    };

    enum ListOption {
      all = 0,
      since
    };

    typedef ListOption& ListOption_out;

    class SpecifiedServiceTypes;
    typedef TFixVar<SpecifiedServiceTypes> SpecifiedServiceTypes_var;
    typedef SpecifiedServiceTypes_var SpecifiedServiceTypes_out;

    class SpecifiedServiceTypes {
      public:
        typedef SpecifiedServiceTypes_var _var_type;
        ListOption _discriminator;

      public:
        struct __m {
          IncarnationNumber incarnation;
        } _m;

      public:
        #ifdef HAVE_EXPLICIT_STRUCT_OPS
        SpecifiedServiceTypes();
        ~SpecifiedServiceTypes();
        SpecifiedServiceTypes( const SpecifiedServiceTypes& s );
        SpecifiedServiceTypes& operator=( const SpecifiedServiceTypes& s );
        #endif //HAVE_EXPLICIT_STRUCT_OPS


        void _d( ListOption _p );
        ListOption _d() const;

        void incarnation( const IncarnationNumber& _p );
        const IncarnationNumber& incarnation() const;
        IncarnationNumber& incarnation();

        void _default();

    };

    struct ServiceTypeExists : public CORBA::UserException {
      #ifdef HAVE_EXPLICIT_STRUCT_OPS
      ServiceTypeExists();
      ~ServiceTypeExists();
      ServiceTypeExists( const ServiceTypeExists& s );
      ServiceTypeExists& operator=( const ServiceTypeExists& s );
      #endif //HAVE_EXPLICIT_STRUCT_OPS

      #ifndef HAVE_EXPLICIT_STRUCT_OPS
      ServiceTypeExists();
      #endif //HAVE_EXPLICIT_STRUCT_OPS
      ServiceTypeExists( const char* _m0 );
      void _throwit() const;
      const char *_repoid() const;
      void _encode( CORBA::DataEncoder &en ) const;
      CORBA::Exception *_clone() const;
      static ServiceTypeExists *_downcast( CORBA::Exception *ex );
      CosTrading::ServiceTypeName_var name;
    };

    typedef ExceptVar<ServiceTypeExists> ServiceTypeExists_var;
    typedef ServiceTypeExists_var ServiceTypeExists_out;

    struct InterfaceTypeMismatch : public CORBA::UserException {
      #ifdef HAVE_EXPLICIT_STRUCT_OPS
      InterfaceTypeMismatch();
      ~InterfaceTypeMismatch();
      InterfaceTypeMismatch( const InterfaceTypeMismatch& s );
      InterfaceTypeMismatch& operator=( const InterfaceTypeMismatch& s );
      #endif //HAVE_EXPLICIT_STRUCT_OPS

      #ifndef HAVE_EXPLICIT_STRUCT_OPS
      InterfaceTypeMismatch();
      #endif //HAVE_EXPLICIT_STRUCT_OPS
      InterfaceTypeMismatch( const char* _m0, const char* _m1, const char* _m2, const char* _m3 );
      void _throwit() const;
      const char *_repoid() const;
      void _encode( CORBA::DataEncoder &en ) const;
      CORBA::Exception *_clone() const;
      static InterfaceTypeMismatch *_downcast( CORBA::Exception *ex );
      CosTrading::ServiceTypeName_var base_service;
      Identifier_var base_if;
      CosTrading::ServiceTypeName_var derived_service;
      Identifier_var derived_if;
    };

    typedef ExceptVar<InterfaceTypeMismatch> InterfaceTypeMismatch_var;
    typedef InterfaceTypeMismatch_var InterfaceTypeMismatch_out;

    struct HasSubTypes : public CORBA::UserException {
      #ifdef HAVE_EXPLICIT_STRUCT_OPS
      HasSubTypes();
      ~HasSubTypes();
      HasSubTypes( const HasSubTypes& s );
      HasSubTypes& operator=( const HasSubTypes& s );
      #endif //HAVE_EXPLICIT_STRUCT_OPS

      #ifndef HAVE_EXPLICIT_STRUCT_OPS
      HasSubTypes();
      #endif //HAVE_EXPLICIT_STRUCT_OPS
      HasSubTypes( const char* _m0, const char* _m1 );
      void _throwit() const;
      const char *_repoid() const;
      void _encode( CORBA::DataEncoder &en ) const;
      CORBA::Exception *_clone() const;
      static HasSubTypes *_downcast( CORBA::Exception *ex );
      CosTrading::ServiceTypeName_var the_type;
      CosTrading::ServiceTypeName_var sub_type;
    };

    typedef ExceptVar<HasSubTypes> HasSubTypes_var;
    typedef HasSubTypes_var HasSubTypes_out;

    struct AlreadyMasked : public CORBA::UserException {
      #ifdef HAVE_EXPLICIT_STRUCT_OPS
      AlreadyMasked();
      ~AlreadyMasked();
      AlreadyMasked( const AlreadyMasked& s );
      AlreadyMasked& operator=( const AlreadyMasked& s );
      #endif //HAVE_EXPLICIT_STRUCT_OPS

      #ifndef HAVE_EXPLICIT_STRUCT_OPS
      AlreadyMasked();
      #endif //HAVE_EXPLICIT_STRUCT_OPS
      AlreadyMasked( const char* _m0 );
      void _throwit() const;
      const char *_repoid() const;
      void _encode( CORBA::DataEncoder &en ) const;
      CORBA::Exception *_clone() const;
      static AlreadyMasked *_downcast( CORBA::Exception *ex );
      CosTrading::ServiceTypeName_var name;
    };

    typedef ExceptVar<AlreadyMasked> AlreadyMasked_var;
    typedef AlreadyMasked_var AlreadyMasked_out;

    struct NotMasked : public CORBA::UserException {
      #ifdef HAVE_EXPLICIT_STRUCT_OPS
      NotMasked();
      ~NotMasked();
      NotMasked( const NotMasked& s );
      NotMasked& operator=( const NotMasked& s );
      #endif //HAVE_EXPLICIT_STRUCT_OPS

      #ifndef HAVE_EXPLICIT_STRUCT_OPS
      NotMasked();
      #endif //HAVE_EXPLICIT_STRUCT_OPS
      NotMasked( const char* _m0 );
      void _throwit() const;
      const char *_repoid() const;
      void _encode( CORBA::DataEncoder &en ) const;
      CORBA::Exception *_clone() const;
      static NotMasked *_downcast( CORBA::Exception *ex );
      CosTrading::ServiceTypeName_var name;
    };

    typedef ExceptVar<NotMasked> NotMasked_var;
    typedef NotMasked_var NotMasked_out;

    struct ValueTypeRedefinition : public CORBA::UserException {
      #ifdef HAVE_EXPLICIT_STRUCT_OPS
      ValueTypeRedefinition();
      ~ValueTypeRedefinition();
      ValueTypeRedefinition( const ValueTypeRedefinition& s );
      ValueTypeRedefinition& operator=( const ValueTypeRedefinition& s );
      #endif //HAVE_EXPLICIT_STRUCT_OPS

      #ifndef HAVE_EXPLICIT_STRUCT_OPS
      ValueTypeRedefinition();
      #endif //HAVE_EXPLICIT_STRUCT_OPS
      ValueTypeRedefinition( const char* _m0, const PropStruct& _m1, const char* _m2, const PropStruct& _m3 );
      void _throwit() const;
      const char *_repoid() const;
      void _encode( CORBA::DataEncoder &en ) const;
      CORBA::Exception *_clone() const;
      static ValueTypeRedefinition *_downcast( CORBA::Exception *ex );
      CosTrading::ServiceTypeName_var type_1;
      PropStruct definition_1;
      CosTrading::ServiceTypeName_var type_2;
      PropStruct definition_2;
    };

    typedef ExceptVar<ValueTypeRedefinition> ValueTypeRedefinition_var;
    typedef ValueTypeRedefinition_var ValueTypeRedefinition_out;

    struct DuplicateServiceTypeName : public CORBA::UserException {
      #ifdef HAVE_EXPLICIT_STRUCT_OPS
      DuplicateServiceTypeName();
      ~DuplicateServiceTypeName();
      DuplicateServiceTypeName( const DuplicateServiceTypeName& s );
      DuplicateServiceTypeName& operator=( const DuplicateServiceTypeName& s );
      #endif //HAVE_EXPLICIT_STRUCT_OPS

      #ifndef HAVE_EXPLICIT_STRUCT_OPS
      DuplicateServiceTypeName();
      #endif //HAVE_EXPLICIT_STRUCT_OPS
      DuplicateServiceTypeName( const char* _m0 );
      void _throwit() const;
      const char *_repoid() const;
      void _encode( CORBA::DataEncoder &en ) const;
      CORBA::Exception *_clone() const;
      static DuplicateServiceTypeName *_downcast( CORBA::Exception *ex );
      CosTrading::ServiceTypeName_var name;
    };

    typedef ExceptVar<DuplicateServiceTypeName> DuplicateServiceTypeName_var;
    typedef DuplicateServiceTypeName_var DuplicateServiceTypeName_out;

    virtual IncarnationNumber incarnation() = 0;

    virtual IncarnationNumber add_type( const char* name, const char* if_name, const PropStructSeq& props, const ServiceTypeNameSeq& super_types ) = 0;
    virtual void remove_type( const char* name ) = 0;
    virtual ServiceTypeNameSeq* list_types( const SpecifiedServiceTypes& which_types ) = 0;
    virtual TypeStruct* describe_type( const char* name ) = 0;
    virtual TypeStruct* fully_describe_type( const char* name ) = 0;
    virtual void mask_type( const char* name ) = 0;
    virtual void unmask_type( const char* name ) = 0;

  protected:
    ServiceTypeRepository() {};
  private:
    ServiceTypeRepository( const ServiceTypeRepository& );
    void operator=( const ServiceTypeRepository& );
};

// Stub for interface ServiceTypeRepository
class ServiceTypeRepository_stub:
  virtual public ServiceTypeRepository
{
  public:
    virtual ~ServiceTypeRepository_stub();
    IncarnationNumber incarnation();

    IncarnationNumber add_type( const char* name, const char* if_name, const PropStructSeq& props, const ServiceTypeNameSeq& super_types );
    void remove_type( const char* name );
    ServiceTypeNameSeq* list_types( const SpecifiedServiceTypes& which_types );
    TypeStruct* describe_type( const char* name );
    TypeStruct* fully_describe_type( const char* name );
    void mask_type( const char* name );
    void unmask_type( const char* name );

  private:
    void operator=( const ServiceTypeRepository_stub& );
};

class ServiceTypeRepository_skel :
  virtual public StaticMethodDispatcher,
  virtual public ServiceTypeRepository
{
  public:
    ServiceTypeRepository_skel( const CORBA::BOA::ReferenceData & = CORBA::BOA::ReferenceData() );
    virtual ~ServiceTypeRepository_skel();
    ServiceTypeRepository_skel( CORBA::Object_ptr obj );
    virtual bool dispatch( CORBA::StaticServerRequest_ptr _req, CORBA::Environment &_env );
    ServiceTypeRepository_ptr _this();

};

#endif // !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE_CosTradingRepos)

#ifndef MICO_NO_TOPLEVEL_MODULES

};
#endif



#ifndef MICO_CONF_NO_POA

#endif // MICO_CONF_NO_POA

#if !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE__GLOBAL)

extern CORBA::StaticTypeInfo *_marshaller_CosTradingRepos_ServiceTypeRepository_PropertyMode;

extern CORBA::StaticTypeInfo *_marshaller_CosTradingRepos_ServiceTypeRepository_PropStruct;

extern CORBA::StaticTypeInfo *_marshaller_CosTradingRepos_ServiceTypeRepository_IncarnationNumber;

extern CORBA::StaticTypeInfo *_marshaller_CosTradingRepos_ServiceTypeRepository_TypeStruct;

extern CORBA::StaticTypeInfo *_marshaller_CosTradingRepos_ServiceTypeRepository_ListOption;

extern CORBA::StaticTypeInfo *_marshaller_CosTradingRepos_ServiceTypeRepository_SpecifiedServiceTypes;

extern CORBA::StaticTypeInfo *_marshaller_CosTradingRepos_ServiceTypeRepository_ServiceTypeExists;

extern CORBA::StaticTypeInfo *_marshaller_CosTradingRepos_ServiceTypeRepository_InterfaceTypeMismatch;

extern CORBA::StaticTypeInfo *_marshaller_CosTradingRepos_ServiceTypeRepository_HasSubTypes;

extern CORBA::StaticTypeInfo *_marshaller_CosTradingRepos_ServiceTypeRepository_AlreadyMasked;

extern CORBA::StaticTypeInfo *_marshaller_CosTradingRepos_ServiceTypeRepository_NotMasked;

extern CORBA::StaticTypeInfo *_marshaller_CosTradingRepos_ServiceTypeRepository_ValueTypeRedefinition;

extern CORBA::StaticTypeInfo *_marshaller_CosTradingRepos_ServiceTypeRepository_DuplicateServiceTypeName;

extern CORBA::StaticTypeInfo *_marshaller_CosTradingRepos_ServiceTypeRepository;

extern CORBA::StaticTypeInfo *_marshaller__seq_CosTradingRepos_ServiceTypeRepository_PropStruct;

#endif // !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE__GLOBAL)


#if !defined(MICO_NO_TOPLEVEL_MODULES) && !defined(MICO_IN_GENERATED_CODE)
#include <mico/template_impl.h>
#endif

#endif
